<?php
class Ameex_Insurance_Block_Adminhtml_Reports_ActivationDetails_GridContainer_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
	public function __construct()
	{
		parent::__construct();
		$this->setId('activationDetails');
		$this->setUseAjax(true);		
		$this->setDefaultSort('id');
		$this->setDefaultDir('DESC');
		$this->setSaveParametersInSession(true);
	}

	protected function _prepareCollection()
	{
		$collection = Mage::getModel('ameex_insurance/activationDetails')->getCollection();
if (strpos($this->getGridUrl(), 'activationNo') !== false) { $collection->addFieldToFilter('imei', array('null' => true))->getSelect(); }
   
		$collection->getSelect()->joinLeft(
				Mage::getConfig()->getTablePrefix().'insurance_companies',
				'main_table.insurance_company_id ='.Mage::getConfig()->getTablePrefix().'insurance_companies.id',
				array('email as e_mail')
        );
		$collection->getSelect()->joinLeft(
				Mage::getConfig()->getTablePrefix().'sales_flat_order_item',
				'main_table.order_item_id ='.Mage::getConfig()->getTablePrefix().'sales_flat_order_item.item_id',
				array('name as product_name')
        );
        $collection->getSelect()->joinLeft(
				Mage::getConfig()->getTablePrefix().'sales_flat_order',
				'sales_flat_order_item.order_id ='.Mage::getConfig()->getTablePrefix().'sales_flat_order.entity_id',
				array('increment_id as order_number')
        );



		$this->setCollection($collection);
		return parent::_prepareCollection();
	}
    
   protected function _prepareColumns()
   {
		$options = Mage::getModel('ameex_insurance/options');


		$this->addColumn('id', array(
            'header' => Mage::helper('ameex_insurance')->__('ID'),
            'index' => 'id',
            'filter_index' => 'main_table.id',
        ));

		$this->addColumn('activated_at', array(
            'header' => Mage::helper('ameex_insurance')->__('Activated On'),
            'index' => 'activated_at',
            'type' => 'datetime',
            'renderer'  => 'Ameex_Insurance_Block_Adminhtml_Reports_ActivationDetails_GridContainer_Grid_Renderers_ActivatedAt',
        ));

		$this->addColumn('order_number', array(
            'header' => Mage::helper('ameex_insurance')->__('Order Number'),
            'index' => 'order_number',
            'filter_index' => 'sales_flat_order.increment_id'
        ));
		
		$this->addColumn('email', array(
			'header' => Mage::helper('ameex_insurance')->__('Customer E-mail'),
			'index' => 'email',
			'filter_index' => 'main_table.email'
		));

		$this->addColumn('product_name', array(
			'header' => Mage::helper('ameex_insurance')->__('Product Name'),
			'index'	 => 'product_name',
			'filter_index' => 'sales_flat_order_item.name'
		));

		$this->addColumn('imei', array(
			'header' => Mage::helper('ameex_insurance')->__('IMEI'),
			'index'	 => 'imei',
		));

		$this->addColumn('company_name', array(
			'header' => Mage::helper('ameex_insurance')->__('Company Name'),
			'type'      => 'options',
			'options'    => $options->getCompanies(),
			'index' => 'insurance_company_id',
		));
			   
		$this->addColumn('company_email', array(
			'header' => Mage::helper('ameex_insurance')->__('Company E-mail'),
			'index'	 => 'e_mail',
			'filter_index' => 'insurance_companies.email',
		));

		$this->addColumn('view_details',
			array(
				'header'    => Mage::helper('ameex_insurance')->__('View Details'),
				'type'      => 'action',
				'getter'    => 'getId',
                'actions'   => array(
                    array(
                        'caption' => Mage::helper('ameex_insurance')->__('View Details'),
                        'url'     => array('base'=>'*/*/view'),
                        'field'   => 'id'
                    )
                ),
				'filter'    => false,
				'sortable'  => false,
				'is_system' => true,
		));

		$this->addExportType('*/*/exportCsv', Mage::helper('ameex_insurance')->__('CSV'));

		return parent::_prepareColumns();
    }

	public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current'=>true));
    }
    
    public function getRowUrl($row)
    {
        return $this->getUrl('*/*/view', array('id' => $row->getId()));
    }
}
