<?php
class Ameex_Insurance_Block_Adminhtml_Reports_ClaimDetails_EditFormContainer_Edit_Tab_Form extends Mage_Adminhtml_Block_Widget_Form
{
	protected function _prepareForm()
	{
		$form = new Varien_Data_Form();
		$this->setForm($form);
		$fieldset = $form->addFieldset('claim_details', array('legend'=>Mage::helper('ameex_insurance')->__('Claim Details')));
		$currencyCode = '<strong>['.Mage::app()->getStore()->getCurrentCurrencyCode().']</strong>';
	 
		$model = Mage::registry('claim_details');
		
		$fieldset->addField('first_name', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('First Name'),
			'name'      => 'first_name',
		));

		$fieldset->addField('last_name', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Last Name'),
			'name'      => 'last_name',
		));

		$fieldset->addField('email', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('E-mail'),
			'name'      => 'email',
		));

		$fieldset->addField('device_number', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Device Number'),
			'name'      => 'device_number',
		));

		$fieldset->addField('alternate_phone', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Alternate Phone'),
			'name'      => 'alternate_phone',
		));

		$fieldset->addField('primary_phone', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Primary Phone'),
			'name'      => 'primary_phone',
		));

		$fieldset->addField('address1', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Address'),
			'name'      => 'address1',
		));

		$fieldset->addField('address2', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__(' '),
			'name'      => 'address2',
		));

		$fieldset->addField('city', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('City'),
			'name'      => 'city',
		));

		$fieldset->addField('state', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('State'),
			'name'      => 'state',
		));

		$fieldset->addField('zipcode', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Zipcode'),
			'name'      => 'zipcode',
		));

		$fieldset->addField('country', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Country'),
			'name'      => 'country',
		));

		// $fieldset->addField('policy_number', 'text', array(
		// 	'label'     => Mage::helper('ameex_insurance')->__('Policy Number'),
		// 	'name'      => 'policy_number',
		// ));

		$fieldset->addField('damaged_at', 'date', array(
			'label'     => Mage::helper('ameex_insurance')->__('Damaged At'),
			'name'      => 'damaged_at',
			'format'    => Mage::app()->getLocale()->getDateFormat(Mage_Core_Model_Locale::FORMAT_TYPE_SHORT),
			'after_element_html' => "<strong>MM/DD/YYYY</strong>",
		));

		$fieldset->addField('damage_type', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Damage Type'),
			'name'      => 'damage_type',
		));

		$fieldset->addField('device_work', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Is device working?'),
			'name'      => 'device_work',
		));

		$fieldset->addField('description', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Description'),
			'name'      => 'description',
		));

		$fieldset->addField('amount_paid', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Amount Paid'),
			'name'      => 'amount_paid',
			'after_element_html' => $currencyCode,
		));

		$fieldset->addField('agree_additional_charge', 'text', array(
			'label'     => Mage::helper('ameex_insurance')->__('Agree Additional Charge'),
			'name'      => 'agree_additional_charge',
		));

		if(!is_null($model))
			$form->setValues($model->getData());
			
		return parent::_prepareForm();
	}
}