<?php
class Ameex_Insurance_Block_Adminhtml_Retailers_GridContainer_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
   public function __construct()
   {
       parent::__construct();
       $this->setId('retailers');
       $this->setDefaultSort('id');
       $this->setDefaultDir('ASC');
       $this->setUseAjax(true);
       $this->setSaveParametersInSession(true);
   }
   
   protected function _prepareCollection()
   {
      $collection = Mage::getModel('ameex_insurance/retailers')->getCollection();
      $this->setCollection($collection);
      return parent::_prepareCollection();
   }
    
   protected function _prepareColumns()
   {
		$this->addColumn('id', array(
                    'header' => Mage::helper('ameex_insurance')->__('Retailer Id'),
                    'index' => 'id',
               ));
		
		$this->addColumn('retailer_name', array(
                    'header' => Mage::helper('ameex_insurance')->__('Retailer Name'),
                    'index' => 'retailer_name',
               ));

		$this->addColumn('retailer_email', array(
                    'header' => Mage::helper('ameex_insurance')->__('Retailer Email'),
                    'index' => 'retailer_email',
               ));

             $this->addColumn('retailer_code', array(
                    'header' => Mage::helper('ameex_insurance')->__('Retailer Code'),
                    'index' => 'retailer_code',
               ));
       
		$this->addColumn('retailer_website', array(
                    'header' => Mage::helper('ameex_insurance')->__('Retailer Website'),
                    'index' => 'retailer_website',
               ));
            $this->addColumn('status', array(
                    'header' => Mage::helper('ameex_insurance')->__('Status'),
                    'index' => 'status',
                    'type' => 'options',
                    'options' => Mage::getModel('ameex_insurance/options')->getEnableDisable(),
               ));                
		
		$this->addExportType('*/*/exportCsv', Mage::helper('ameex_insurance')->__('CSV'));
       
        return parent::_prepareColumns();
    }

	public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current'=>true));
    }
    
    public function getRowUrl($row)
    {
        return $this->getUrl('*/*/edit', array('id' => $row->getId()));
    }
    
    protected function _prepareMassaction()
	{
		$this->setMassactionIdField('id');
		$this->getMassactionBlock()->setFormFieldName('id');
		$this->getMassactionBlock()->addItem('delete', array(
			'label'		=> Mage::helper('ameex_insurance')->__('Delete'),
			'url'  		=> $this->getUrl('*/retailers/massDelete', array('' => '')),
		));                
		 
		return $this;
	}
}
