<?php
class Ameex_Insurance_Helper_Data extends Mage_Core_Helper_Abstract
{
	public function sendEmail($templateId, $recipientEmail, $recipientName, $vars=array())
	{
		$storeId = Mage::app()->getStore()->getId();
		$sender = Array('name' => Mage::getStoreConfig('trans_email/ident_general/name'),
						'email' => Mage::getStoreConfig('trans_email/ident_general/email'));
		Mage::getModel('core/email_template')->sendTransactional($templateId, $sender, $recipientEmail, $recipientName, $vars, $storeId);
	}
	
	public function allocateInsuranceCompanies($orderItemWithCompanyId,$allottedCompanyId)
    {
		foreach($orderItemWithCompanyId as $companyId => $orderItems) {
			foreach($orderItems as $orderItem) {
				if (is_object($orderItem)) {
					Mage::getModel("ameex_insurance/companyOrderItem")->setCompanyId($companyId)->setOrderItemId($orderItem->getId())->save();
				}
				else {
					Mage::getModel("ameex_insurance/companyOrderItem")->setCompanyId($companyId)->setOrderItemId($orderItem)->save();
				}
			}
			
			//$this->sendEmail($templateId, $senderEmail, $senderName, $recipientEmail, $recipientName, $orderItemIds);
		}

		/********************
		*	Atleast one product should be assigned to this company in this Order
		********************/
		
		if(count($orderItemWithCompanyId[$allottedCompanyId]) > 0) {

			/********************
			*	Increase the orders_assigned_in_this_cycle value by 1
			********************/
			
			$allottedCompany = Mage::getModel("ameex_insurance/company")->load($allottedCompanyId);
			$ordersAssignedInThisCycle = $allottedCompany->getOrdersAssignedInThisCycle();
			$allottedCompany->setOrdersAssignedInThisCycle(($ordersAssignedInThisCycle+1))->save();

			$this->findNextEligibleCompany();
			$newCompanyId = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("to_be_assigned",array("eq"=>"1"))->getFirstItem()->load()->getId();
			if($newCompanyId != $allottedCompanyId)

				/********************
				*	Change the value of to_be_assigned from 1 to 0 if and only if some other company is the next eligible one.
				********************/
				
				Mage::getModel("ameex_insurance/company")->load($allottedCompanyId)->setToBeAssigned(0)->save();
		}
	}
	
	public function getAllottedCompanyId()
	{
		$company = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("status",array("eq"=>"1"))->addFieldToFilter("to_be_assigned",array("eq"=>"1"))->addFieldToFilter("orders_per_cycle",array("gt"=>new Zend_Db_Expr('orders_assigned_in_this_cycle')));
		if(count($company) > 0)
			return $company->getFirstItem()->getId();
		else {

			/********************
			*	The company which is going to receive this order might be disabled or it's Orders per cycle value has been reduced or 
			*	all the companies are created just now.
			********************/
			
			$reducedOrdersPerCycleCompany = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("status",array("eq"=>"1"))->addFieldToFilter("to_be_assigned",array("eq"=>"1"));
			if (count($reducedOrdersPerCycleCompany) > 0) {
				/********************
				*	The company which is going to receive this order is having reduced Orders per cycle value. So, find the next 
				*	eligible company
				********************/

				$this->findNextEligibleCompany();
				$newCompanyId = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("to_be_assigned",array("eq"=>"1"))->getFirstItem()->load()->getId();
				if($newCompanyId != $reducedOrdersPerCycleCompany->getFirstItem()->load()->getId())
					$reducedOrdersPerCycleCompany->setToBeAssigned(0)->save();
				return Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("status",array("eq"=>"1"))->addFieldToFilter("to_be_assigned",array("eq"=>"1"))->addFieldToFilter("orders_per_cycle",array("gt"=>new Zend_Db_Expr('orders_assigned_in_this_cycle')))->getFirstItem()->getId();
			} else {
				
				/********************
				*	The company which is going to receive this order might be disabled or all the companies are created just now.
				********************/
				
				$disabledCompany = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("to_be_assigned",array("eq"=>"1"));
				if (count($disabledCompany) > 0) {

					/********************
					*	The company which is going to receive this order is currently disabled. So, find the next eligible company
					********************/

					$this->findNextEligibleCompany();
					$newCompanyId = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("to_be_assigned",array("eq"=>"1"))->getFirstItem()->load()->getId();
					if($newCompanyId != $disabledCompany->getFirstItem()->load()->getId())
						$disabledCompany->setToBeAssigned(0)->save();
					return Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("status",array("eq"=>"1"))->addFieldToFilter("to_be_assigned",array("eq"=>"1"))->addFieldToFilter("orders_per_cycle",array("gt"=>new Zend_Db_Expr('orders_assigned_in_this_cycle')))->getFirstItem()->getId();
				} else {

					/********************
					*	All the companies are created just now. So, return the first company which is enabled.
					********************/
					
					return Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("status",array("eq"=>"1"))->getFirstItem()->getId();
				}
			}
		}
	}
	
	public function activate($data)
	{
		$activationData = Mage::getModel("ameex_insurance/activationDetails");
		$activationData->setData($data);
		$activationData->save();
		
		//$helper->sendEmail($templateId, $senderEmail, $senderName, $recipientEmail, $recipientName); // To insurance company
		//$helper->sendEmail($templateId, $senderEmail, $senderName, $recipientEmail, $recipientNamec); // To customer
	}

	/********************
	*	Find the next eligible company
	********************/

	public function findNextEligibleCompany()
	{
		$companyCollection = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("status",array("eq"=>"1"))->addFieldToFilter("orders_per_cycle",array("gt"=>new Zend_Db_Expr('orders_assigned_in_this_cycle')));
		if(count($companyCollection) == 0) {

			/********************
			*	All companies received orders for this cycle. So start from beginning
			********************/
			
			$companies = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("status",array("eq"=>"1"));
			foreach($companies as $company) {
				$company->setOrdersAssignedInThisCycle(0)->save();
			}
			$companies->getFirstItem()->load()->setToBeAssigned(1)->save();
		}
		else {

			/********************
			*	Pick the next company in this cycle
			********************/
			
			$allottedCompanyId = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("to_be_assigned",array("eq"=>"1"))->getFirstItem()->getId();
			$companyCollection = Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("orders_per_cycle",array("gt"=>new Zend_Db_Expr('orders_assigned_in_this_cycle')))->addFieldToFilter("status",array("eq"=>"1"))->addFieldToFilter("id",array("gt"=>$allottedCompanyId));
			if(count($companyCollection) == 0) {
				Mage::getModel("ameex_insurance/company")->getCollection()->addFieldToFilter("status",array("eq"=>"1"))->addFieldToFilter("orders_per_cycle",array("gt"=>new Zend_Db_Expr('orders_assigned_in_this_cycle')))->getFirstItem()->load()->setToBeAssigned(1)->save();
			}
			else {
				$companyCollection->getFirstItem()->load()->setToBeAssigned(1)->save();
			}
		}
	}
}