<?php
class Ameex_Insurance_Reports_ClaimDetailsController extends Mage_Adminhtml_Controller_Action
{
	public function indexAction()
	{
		$this->loadLayout();
		$this->_setActiveMenu('insurance/reports');
		$this->_addContent($this->getLayout()->createBlock('ameex_insurance/adminhtml_reports_claimDetails_gridContainer'));
        $this->renderLayout();
	}
	
	public function exportCsvAction()
    {
        $fileName   = 'ClaimDetails.csv';
        $grid       = $this->getLayout()->createBlock('ameex_insurance/adminhtml_reports_claimDetails_gridContainer_grid');
        $this->_prepareDownloadResponse($fileName, $grid->getCsvFile());
    }
    
    public function gridAction()
    {
        $this->loadLayout();
        $this->getResponse()->setBody(
               $this->getLayout()->createBlock('ameex_insurance/adminhtml_reports_claimDetails_gridContainer_grid')->toHtml()
        );
    }
    
    public function viewAction()
    {
        // Get id if available
        $id  = $this->getRequest()->getParam('id');
        $model = Mage::getModel('ameex_insurance/claimDetails');
     
        if ($id) {
            // Load record
            $model->load($id);
     
            // Check if record is loaded
            if (!$model->getId()) {
                Mage::getSingleton('adminhtml/session')->addError($this->__('This report no longer exists'));
                $this->_redirect('*/*/*');
     
                return;
            }  
        }  
     
        $this->_title("Claim Details");
        $data = Mage::getSingleton('adminhtml/session')->getFormData(true);
        if (!empty($data)) {
			$model->setData($data);
		}     
        Mage::register('claim_details', $model);
     
        $this->loadLayout();		
		$this->_setActiveMenu('insurance/reports');
		$this->_addContent($this->getLayout()->createBlock('ameex_insurance/adminhtml_reports_claimDetails_editFormContainer'))
			 ->_addLeft($this->getLayout()->createBlock('ameex_insurance/adminhtml_reports_claimDetails_editFormContainer_edit_tabs'));
        $this->renderLayout();
	}
}
