<?php

class Ameex_Insurance_ClaimController extends Mage_Core_Controller_Front_Action
{
	public function indexAction()
	{
		$data = $this->getRequest()->getParams();
		$imei = $data[device];
		$activationData = Mage::getModel("ameex_insurance/activationDetails")->getCollection()->addFieldToFilter("imei",$imei);
		if(count($activationData) == 0) {

			/********************
			*	IMEI not activated
			********************/
			
			Mage::getSingleton("core/session")->addError("The IMEI number that you have entered is not yet activated for insurance.");
        	$this->_redirect('*/*/result');
		}
		else {

			/********************
			*	IMEI activated
			********************/

			$activation = $activationData->getFirstItem();
			$purchasedOn = $activation->getCreatedAt();
			$activatedOn = $activation->getActivatedAt();
			$timeTakenForActivation = strtotime($activatedOn) - strtotime($purchasedOn);
			$actualActivationDate = ($timeTakenForActivation <= 2592000 || $timeTakenForActivation <= 5184000) ? $activatedOn : (strtotime($purchasedOn) + 2592000);
			$insurancePeriodExceeded = ((time() - strtotime($actualActivationDate)) > 31536000) ? true : false;

			if ($insurancePeriodExceeded) {
				
				/********************
				*	Outside Insurance period
				********************/
				$this->saveclaimAction();
				Mage::getSingleton("core/session")->addError("Your insurance period expired.");
        		$this->_redirect('*/*/result');
				
			} else {
				
				/********************
				*	Within the Insurance period
				********************/

				$isMinimumPeriodExceeded = ((time() - strtotime($actualActivationDate)) > 2592000) ? true : false;
				if ($isMinimumPeriodExceeded) {
					
					/********************
					*	Minimum waiting period exceeded
					********************/
					if($data["type-of-damage"]!="Screen Damage" || $data["type-of-damage"]!="Water Damage"){
					  $transactionStatus = $this->_processCard($data);
					}
				
					
					if ($transactionStatus[0] == 1) {
						
						/********************
						*	Transaction success.
						********************/

						$claim = Mage::getModel("ameex_insurance/claimDetails");
						$claim->setFirstName($data["first-name"]);
					    $claim->setLastName($data["last-name"]);
					    $claim->setEmail($data["email"]);
					    $claim->setDeviceNumber($data["device"]);
					    $claim->setPrimaryPhone($data["primary-phone"]);
					    $claim->setAlternatePhone($data["alternate-phone"]);
					    $claim->setAddress1($data["address-1"]);
					    $claim->setCity($data["city"]);
					    $claim->setState($data["state"]);
					    // $claim->setPolicyNumber($data["policy"]);
					    $claim->setAddress2($data["address-2"]);
					    $claim->setZipcode($data["zip"]);
					    $claim->setCountry($data["country"]);
					    $claim->setDamagedAt($data["date-of-damage"]);
					    $claim->setDamageType($data["type-of-damage"]);						
					    $claim->setDeviceWork($data["does-your-device-still-work"]);
					    $claim->setDescription($data["description-of-incident"]);
						$claim->setDamageMonth($data["type-of-damage_month"]);
						$claim->setPhoneModel($data["phone_model"]);
						if($data["type-of-damage"]=="Screen Damage" || $data["type-of-damage"]=="Water Damage"){
						 $warStatus = "Out Of Warranty";	
						}else{
						$warStatus = "In Warranty";	
						}
						$claim->setWarranty($warStatus);
						$_SESSION['uniqedevice'] = $data["device"];					
					    ($data["additional-5-95-charge"] == "OK") ? $claim->setAmountPaid(30.95) : $claim->setAmountPaid(25);
					    $claim->setAgreeAdditionalCharge($data["additional-5-95-charge"]);
					    $claim->setClaimedAt(time());
					    $claim->save();

					    /********************
						*	To customer
						********************/
						
						$this->sendCustomerMail();
						//$customerEmail = $claim->getEmail();
						
						// mail($customerEmail, 'We received your claim request.', "We received your claim request.");

						/********************
						*	To Insurance Company
						********************/
						$this->SendInsusCompemailAction();
						$activationDetailsForThisImei = Mage::getModel("ameex_insurance/activationDetails")->load($claim->getDeviceNumber(),"imei");						
						$insuranceCompany = Mage::getModel("ameex_insurance/company")->load($activationDetailsForThisImei->getInsuranceCompanyId());
						
						
						// mail($insuranceCompany->getEmail(), 'One claim request arrived', "One claim request arrived");

						/********************
						*	To admin
						********************/
						
						$adminEmail = Mage::getStoreConfig('trans_email/ident_general/email');						
						$this->sendAdminMail($adminEmail);
						$additionalCharge = ($data["additional-5-95-charge"] == "OK") ? "Customer agreed for additional charge." : "Customer not agreed for additional charge.";
						// mail($adminEmail, "One claim request arrived and the Insurance company notified. ".$additionalCharge, "One claim request arrived and the Insurance company notified. ".$additionalCharge);

					    Mage::getSingleton("core/session")->addSuccess("Thanks for your payment. Our support team will contact you at the earliest.");
			        	$this->_redirect('*/*/result');
					} else {
						
						/********************
						*	Transaction failed.
						********************/
                         $this->saveclaimAction();
						//$error = "There was an error processing your request. Please try again or contact our support. We thank you!<br />Error: ".$transactionStatus[3];
						Mage::getSingleton("core/session")->addError($error);
			        	$this->_redirect('*/*/result');	
					}	
				} else {
					
					/********************
					*	Still within the Minimum waiting period
					********************/
					$this->saveclaimAction();
					Mage::getSingleton("core/session")->addError("You have activated your ShieldX2 protection on ".date('m/d/Y',strtotime($actualActivationDate)).". Before submitting a claim, you have to wait for 30 days after Activation.");
			        $this->_redirect('*/*/result');	
				}
			}			
		}
	}




	public function resultAction()
	
	{		
           Mage::getSingleton("core/session")->addSuccess($this->set_html_value());
		   $this->loadLayout();
		   $this->renderLayout();		
	}

	private function _processCard($data) {
		$seed = time();
        $post_values = array(
            "x_login" => "87tmGXBU8QH",
            "x_tran_key" => "96sj8M5s8PD87d2C",
            "x_version" => "3.1",
            "x_delim_data" => "TRUE",
            "x_delim_char" => "|",
            "x_relay_response" => "FALSE",
            "x_type" => "AUTH_CAPTURE",
            "x_method" => "CC",
            "x_card_num" => $data["number-cc"],
            "x_exp_date" => $data["exp-month-cc"] . $data["exp-year-cc"],
            "x_amount" => ($data["additional-5-95-charge"] == "OK") ? "30.95" : "25.00",
            "x_description" => "Claim #: " . $seed,
            "x_first_name" => $data["first-name-cc"],
            "x_last_name" => $data["last-name-cc"],
            "x_address" => $data["address-1"] . " " . $data["address-2"],
            "x_state" => $data["state"],
            "x_zip" => $data["zip"],
            "x_country" => $data["country"]
        );
        $post_string = "";
        foreach($post_values as $key=>$value) {
            $post_string .= "$key=" . urlencode($value) . "&";
        }
        $post_string = rtrim($post_string,"& ");
        //$request = curl_init("https://secure.authorize.net/gateway/transact.dll");
        $request = curl_init("https://test.authorize.net/gateway/transact.dll");
        curl_setopt($request,CURLOPT_HEADER,0);
        curl_setopt($request,CURLOPT_RETURNTRANSFER,1);
        curl_setopt($request,CURLOPT_POSTFIELDS,$post_string);
        curl_setopt($request,CURLOPT_SSL_VERIFYPEER,FALSE);
        $post_response = curl_exec($request);
        curl_close($request);
        $response_array = explode($post_values["x_delim_char"],$post_response);
        return $response_array;
    }
	protected function set_html_value()
	{
		//$_POST['uniqedevice']='355876061361584';
		$connection = Mage::getSingleton('core/resource')->getConnection('core_read');
		$select = $connection->select()
		->from('insurance_claim_details', array('*'))
		->where('device_number=?',@$_SESSION['uniqedevice']);	
		// group by name
		$rowsArray = $connection->fetchRow($select); // return all rows
		//$rowArray =$connection->fetchRow($select);   //return row
		 Mage::register('selectItem', $rowsArray);
		// echo "<pre>";
		 //print($rowsArray['country']);
		
		
		
		$html = '<strong>supplier details : <span style="text-align:right"><input type="button" onclick="window.print();" value="print packaging slip" /></span></strong>
<table width="500" border="1">
<tr><td colspan="2"></td></tr>
  <tr>
    <td width="225"><strong>Supplier Name</strong></td>
    <td width="259">Supplier </td>
   
  </tr>
  <tr>
      <td>Supplier Email</td>
    <td>Supplier@shieldx2.com</td>
   
  </tr>
  <tr>
      <td>Supplier Phone</td>
    <td>1234567892</td>
   
  </tr>
</table>
<strong>Customer Details : </strong><br>
<table width="500" border="1">
  <tr>
    <td width="227">Name</td>
    <td width="257">'.$rowsArray['first_name'].'</td>
   
  </tr>
  <tr>
      <td>IMEI</td>
    <td>'.$rowsArray['device_number'].'</td>
   
  </tr>
  <tr>
      <td>Adress</td>
    <td>'.$rowsArray['address1'].'</td>
   
  </tr>
   <tr>
      <td>City</td>
    <td>'.$rowsArray['city'].'</td>
   
  </tr> 
 <tr>
      <td>State</td>
    <td>'.$rowsArray['state'].'</td>
   
  </tr>
   <tr>
      <td>Zip Code</td>
    <td>'.$rowsArray['zipcode'].'</td>
   
  </tr> 
   <tr>
      <td>Country</td>
    <td>'.$rowsArray['country'].'</td>
   
  </tr>
   <tr>
      <td>Damage Type</td>
    <td>'.$rowsArray['damage_type'].'</td>
   
  </tr>
   <tr>
      <td>Device Work</td>
    <td>'.$rowsArray['device_work'].'</td>
   
  </tr>
   <tr>
      <td>Phone Model </td>
    <td>'.$rowsArray['phone_model'].'</td>
   
  </tr>
  <tr>
      <td>warranty</td>
    <td>'.$rowsArray['warranty'].'</td>   
  </tr>
</table>';
unset($_SESSION['uniqedevice']);
 return $html;
	}
protected function sendAdminMail($sendTo)
{
	$storeData =  $this->getemailAddressForms();
	$to=$sendTo;	
	$subject="Claim Alert";
	$message='
			<h2>Claim Alert </h2>
			<p>Dear Insurance provider</p>
			<p>You have received a claim !</p>
			<div>
			<table>
			<tr>
			<td>Customer:</td>
			<td>'.$storeData['FirstNane'].'</td>
			<td>Email Address:</td>
			<td>'.$storeData['EmailAdress'].'</td>
			</tr>
			<tr style="colspan:2">
			<td>Address:</td>
			<td>'.$storeData['address1'].'&nbsp;'.$storeData['address2'].'&nbsp'.$storeData['city'].'&nbsp'.$storeData['country'].'</td>
			<td>Phone Number 1:<br/>Phone Number 2:</td>
			<td>'.$storeData['primary_phone'].'<br/>'.$storeData['alternate_phone'].'</td>			
			</tr>
			</table>';					
	 
	
	$name = $storeData['FirstNane'];
	$email = $storeData['EmailAdress'];
	$headers  = 'MIME-Version: 1.0' . "\r\n";
	$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
	$headers .= 'From:' .$name.' <'.$email.'>' . "\r\n";
	@mail($to, $subject, $message, $headers);
		
	}
	protected function sendCustomerMail()
	{		
	$storeData =  $this->getemailAddressForms();
	$name = $storeData['FirstNane'];
	$email = $storeData['EmailAdress'];		
		
	$to=$email;	
	$subject="sendCustomerMail";
	$message='	
			<div>
			<table width="600px">
			<caption style="text-align:left;"><h3>Phone details:</h3></caption>
			<tr>
			<td>IMEI:</td><td>'.$storeData['iemi_numbe'].'</td>
			<td>Phone type:</td><td>'.$storeData['phone_model'].'</td></tr>
			<tr>
			<td>Type of damage</td><td>'.$storeData['damage_type'].'</td>
			<td>Does your device still work</td><td>'.$storeData['device_work'].'</td>
			</tr>
			</table>
			<p>Description of incident:-<p>
			<p>Dropped phone off the side of my kitchen work-surface onto a tiled floor. Screen cracked<p><br/>
			<table width="1333">
			<tr ><td width="602">Date Device Registered:&nbsp;'.$storeData['damage_date'].'</td>
			<td width="719"> Over 30 days:&nbsp;Yes</br>Less than 60 days:&nbsp;No</td></tr>
			<tr><td>Processing fees paid:&nbsp;'.$storeData['amount_paid'].'</td>
			<td>additional fees paid for new case:&nbsp;'.$storeData['agree_additional_charge'].'</td></tr>
			<tr><td>Unit shipped to&nbsp;'.$storeData[''].'
			</td><td>Date:&nbsp;'.date('Y-m-d').'</td>
			</tr>
			</table>
			</div>';
			
	
	$headers  = 'MIME-Version: 1.0' . "\r\n";
	$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
	$headers .= 'From:' .$name.' <'.$email.'>' . "\r\n";
	@mail($to, $subject, $message, $headers);
		
	}	
	protected function saveclaimAction()
	{
		$claim = Mage::getModel("ameex_insurance/claimDetails");
		$claim->setFirstName($_REQUEST["first-name"]);
		$claim->setLastName($_REQUEST["last-name"]);
		$claim->setEmail($_REQUEST["email"]);
		$claim->setDeviceNumber($_REQUEST["device"]);
		$claim->setPrimaryPhone($_REQUEST["primary-phone"]);
		$claim->setAlternatePhone($_REQUEST["alternate-phone"]);
		$claim->setAddress1($_REQUEST["address-1"]);
		$claim->setCity($_REQUEST["city"]);
		$claim->setState($_REQUEST["state"]);
		// $claim->setPolicyNumber($data["policy"]);
		$claim->setAddress2($_REQUEST["address-2"]);
		$claim->setZipcode($_REQUEST["zip"]);
		$claim->setCountry($_REQUEST["country"]);
		$claim->setDamagedAt($_REQUEST["date-of-damage"]);
		$claim->setDamageType($_REQUEST["type-of-damage"]);						
		$claim->setDeviceWork($_REQUEST["does-your-device-still-work"]);
		$claim->setDescription($_REQUEST["description-of-incident"]);
		$claim->setDamageMonth($_REQUEST["type-of-damage_month"]);
		$claim->setPhoneModel($_REQUEST["phone_model"]);
		if($_REQUEST["type-of-damage"]=="Screen Damage" || $_REQUEST["type-of-damage"]=="Water Damage"){
		 $warStatus = "Out Of Warranty";	
		}else{
		$warStatus = "In Warranty";	
		}
		$claim->setWarranty($warStatus);
		$_SESSION['uniqedevice'] = $_REQUEST["device"];	
		$claim->setClaimedAt(time());
		$claim->save();
		
	}
	public function SendInsusCompemailAction()
	{
		
		
		$storeData =  $this->getemailAddressForms();
		$name = $storeData['FirstNane'];
		$email = $storeData['EmailAdress'];
		
		$to = 'yash@redcubedigital.com';	
		$subject="sendCustomerMail";
		$message='TEST sendinsurance mail ';
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";
		$headers .= 'From:' .$name.' <'.$email.'>' . "\r\n";
		@mail($to, $subject, $message, $headers);
		
	}
	protected function getemailAddressForms()
	{
		$connection = Mage::getSingleton('core/resource')->getConnection('core_read');
		$select = $connection->select()
		->from('insurance_claim_details', array('*'))
		->where('device_number=?',@$_SESSION['uniqedevice']);	
		// group by name
		$rowsArray = $connection->fetchRow($select); // return all rows
		//$rowArray =$connection->fetchRow($select);   //return row
		// Mage::register('selectItem', $rowsArray);
		 
		 
		 $arr =  array('FirstNane'=>$rowsArray['first_name'],
		               'EmailAdress'=>$rowsArray['email'],
					    'address1'=>$rowsArray['address1'],
						'device_number'=>$rowsArray['device_number'],
						'city'=>$rowsArray['city'],
						'state'=>$rowsArray['state'],
						'zipcode'=>$rowsArray['zipcode'],
						'damage_type'=>$rowsArray['damage_type'],
						'device_work'=>$rowsArray['device_work'],
						'country'=>$rowsArray['country'],
						'phone_model'=>$rowsArray['phone_model'],
						'primary_phone'=>$rowsArray['primary_phone'],
						'alternate_phone'=>$rowsArray['alternate_phone'],
						'address2'=>$rowsArray['address2'],
						'iemi_numbe'=>$rowsArray['iemi_numbe'],
						'damage_type'=>$rowsArray['damage_type'],
						'amount_paid'=>$rowsArray['amount_paid'],
						'agree_additional_charge'=>$rowsArray['agree_additional_charge'],
						'device_work'=>$rowsArray['device_work'],
						'damage_date'=>$rowsArray['damage_date']
					   );
		 
		 return $arr;
		
	}
}