<?php

// This file just copies rocketshipit-php7-linux.so to your PHP extension folder
// and adds "extension=rocketshipit-php7-linux.so" to your php.ini file.

// This is an optional step you do not need to install the PHP extension to use 
// RocketShipIt.

// This allows you to call rocketshipit_request(jsonString) from anywhere in PHP.

$rsPHPExtFilename = 'rocketshipit-php7-linux.so';

if (!file_exists($rsPHPExtFilename)) {
    echo 'Could not find RocketShipIt PHP extension'. "\n";
    exit;
}

$extensionDir = ini_get('extension_dir');
if ($extensionDir == '') {
    echo 'Unable to determine extension_dir'. "\n";
    exit;
}

if (!copy(__DIR__. '/'. $rsPHPExtFilename, $extensionDir. '/'. $rsPHPExtFilename)) {
    echo 'Unable to copy RocketShipIt to PHP extension folder.  Please run with sudo or admin privileges.'. "\n";
    exit;
}

if (strpos(file_get_contents(php_ini_loaded_file()), $rsPHPExtFilename) !== false) {
    echo 'Module already exists, updating'. "\n";
} else {
    file_put_contents(php_ini_loaded_file(), "\nextension=$rsPHPExtFilename\n", FILE_APPEND);
}

echo 'You may need to restart your webserver'. "\n";
