<?php
 


class Limex_Advr_Block_Adminhtml_Catalog_Product extends Limex_Advr_Block_Adminhtml_Catalog_Abstract
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(Mage::helper('advr')->__('Products / Bestsellers'));

        return $this;
    }

    protected function _prepareChart()
    {
        $this->setChartType('column');

        $this->_initChart()
            ->setXAxisType('category')
            ->setXAxisField('product_name')
            ;

        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('sum_item_row_total')
            ->setDefaultDir('desc')
            ;

        return $this;
    }

    protected function _prepareToolbar()
    {
        $this->_initToolbar()
            ;

        $this->getToolbar()->getForm()->addField('include_child', 'checkbox', array(
            'name'    => 'include_child',
            'label'   => Mage::helper('advr')->__('Include child products'),
            'value'   => 1,
            'checked' => $this->getIncludeChild(),
        ));

        return $this;
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('catalog/product')
            ->setFilterData($this->getFilterData())
            ->selectColumns(array_merge(
                array('product_id'),
                $this->getVisibleColumns())
            )
            ->groupByColumn('product_id')
            ;

        // echo Limex_SqlFormatter::format($collection->getSelect());
        // die();
        return $collection;
    }


    public function getColumns()
    {
        $columns = array(
            'product_sku' => array(
                'header'              => 'SKU',
                'type'                => 'text',
                'totals_label'        => 'Total',
                'filter_totals_label' => 'Subtotal',
                'link_callback'       => array($this, 'rowUrlCallback'),
            ),

            'product_name' => array(
                'header'         => 'Product',
            ),
        );

        $columns += $this->getBaseProductColumns(true);

        $columns['actions'] = array(
            'header'       => 'Actions',
            'actions'      => array(
                array(
                    'caption'  => Mage::helper('advr')->__('Detail'),
                    'callback' => array($this, 'detailUrlCallback')
                ),
            ),
        );
        
        return $columns;
    }

    public function rowUrlCallback($row)
    {
        return $this->getUrl('adminhtml/catalog_product/edit', array('id' => $row->getProductId()));
    }

    public function detailUrlCallback($row)
    {
        $url = $this->getUrl('advradmin/adminhtml_catalog/productDetail', array(
                'id' => $row->getProductId(),
            )
        );

        return $url;
    }

    public function getIncludeChild()
    {
        if (!$this->getFilterData()->getIncludeChild()) {
            return 0;
        }

        return $this->getFilterData()->getIncludeChild();
    }
}