<?php
 


class Limex_Advr_Block_Adminhtml_Order_Country extends Limex_Advr_Block_Adminhtml_Order_Abstract
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(Mage::helper('advr')->__('Sales By Country'));

        return $this;
    }

    protected function _prepareChart()
    {
        $this->setChartType('geo');

        $this->_initChart()
            ->resetColumns()
            ->addColumn('Country', 'country_id')
            ->addColumn('Grand Total', 'sum_grand_total', 'number')
            ;

        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('sum_grand_total')
            ->setDefaultDir('desc')
            ->setDefaultLimit(200)
            ->setPagerVisibility(false)
            ;

        return $this;
    }

    public function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('sales/order')
            ->setFilterData($this->getFilterData())
            ->selectColumns($this->getVisibleColumns())
            ->groupByColumn('country_id')
            ;

        return $collection;
    }

    public function getColumns()
    {
        $columns = array(
            'country_id' => array(
                'header'         => 'Country',
                'type'           => 'text',
                'frame_callback' => array(Mage::helper('advr/callback'), 'country'),
                'totals_label'   => 'Total',
                'filter'         => false,
            ),
        );

        $columns += $this->getOrderTableColumns(true);

        return $columns;
    }
}