<?php
 


class Limex_Advr_Model_Config
{
    public function dateFormat()
    {
        return Mage::app()->getLocale()->getDateFormat(Mage_Core_Model_Locale::FORMAT_TYPE_MEDIUM);
    }

    public function calendarDateFormat()
    {
        return Varien_Date::convertZendToStrFtime($this->dateFormat());
    }

    public function getCurrencyFormat()
    {
        $format = Mage::app()->getLocale()->getJsPriceFormat();
        
        return str_replace('%s', '#', $format['pattern']);
        
        return str_replace('9', '#', Mage::helper('core')->currency(999999.99, true, false));
    }

    public function isLinkUnderReport()
    {
        return Mage::getStoreConfig('advr/view/link_under_report');
    }

    public function isReplaceDashboardLink()
    {
        return Mage::getStoreConfig('advr/view/replace_dashboard_link');
    }

    public function getChartColumnColor($code)
    {
        $colors = array(
            "#2fd75b",
            "#ff7e0e",
            "#52c4ff",
            "#c7b700",
            "#aaeeee",
            "#ff0066",
            "#eeaaee",
            "#55BF3B",
            "#DF5353",
            "#7798BF",
            "#aaeeee"
        );
            
        if (strpos($code, 'grand_total') || strpos($code, 'row_total')) {
            return '#2fd75b';
        } elseif (strpos($code, 'subtotal')) {
            return '#ff7e0e';
        } elseif (strpos($code, 'discount')) {
            return '#52c4ff';
        } elseif (strpos($code, 'shipping')) {
            return '#c7b700';
        } elseif (strpos($code, 'tax')) {
            return '#aaeeee';
        } elseif (strpos($code, 'refund')) {
            return '#ff0066';
        }

        return $colors[substr(crc32($code), 0, 1)];
    }

    public function getProcessOrderStatuses()
    {
        $statuses = explode(',', Mage::getStoreConfig('advr/report/process_orders'));
        $statuses = array_filter($statuses);

        if (!count($statuses)) {
            $statuses[] = 'complete';
        }

        return $statuses;
    }

    public function getGeoFilesPath()
    {
        $dir = Mage::getBaseDir('media').DS.'advr';
        if (!file_exists($dir)) {
            mkdir($dir);
        }

        return $dir;
    }
}