<?php

$installer = Mage::getResourceModel('catalog/setup','catalog_setup');
$installer->startSetup();

// Add the RTD Attribute Group
foreach ($installer->getAllAttributeSetIds(Mage_Catalog_Model_Product::ENTITY) as $setId) {
    if ( ! $installer->getAttributeGroup(Mage_Catalog_Model_Product::ENTITY, $setId, 'OrderFlow')) {
        $installer->addAttributeGroup(Mage_Catalog_Model_Product::ENTITY, $setId, 'OrderFlow');
    }
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'is_exported')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'is_exported', array(
        'label'                      => 'Exported',
        'sort_order'                 => 1,
        'backend'                    => '',
        'type'                       => 'int',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => 0,
        'wysiwyg_enabled'            => false,
        'input'                      => 'boolean',
        'source'                     => 'eav/entity_attribute_source_boolean',
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'exported_at')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'exported_at', array(
        'label'                      => 'Exported Timestamp',
        'sort_order'                 => 1,
        'backend'                    => '',
        'type'                       => 'datetime',
        'group'                      => 'OrderFlow',
        'frontend'                   => 'eav/entity_attribute_frontend_datetime',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => false,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => false,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'barcode')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'barcode', array(
        'label'                      => 'Barcode',
        'sort_order'                 => 2,
        'backend'                    => '',
        'type'                       => 'varchar',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => true,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'weight_units')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'weight_units', array(
        'label'                      => 'Weight Units',
        'sort_order'                 => 3,
        'backend'                    => '',
        'type'                       => 'varchar',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'length')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'length', array(
        'label'                      => 'Length',
        'sort_order'                 => 4,
        'backend'                    => '',
        'type'                       => 'decimal',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'width')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'width', array(
        'label'                      => 'Width',
        'sort_order'                 => 5,
        'backend'                    => '',
        'type'                       => 'decimal',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'height')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'height', array(
        'label'                      => 'Height',
        'sort_order'                 => 6,
        'backend'                    => '',
        'type'                       => 'decimal',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'area')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'area', array(
        'label'                      => 'Area',
        'sort_order'                 => 7,
        'backend'                    => '',
        'type'                       => 'decimal',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'volume')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'volume', array(
        'label'                      => 'Volume',
        'sort_order'                 => 8,
        'backend'                    => '',
        'type'                       => 'decimal',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'storage_types')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'storage_types', array(
        'label'                      => 'Physical Storage Types',
        'sort_order'                 => 9,
        'backend'                    => '',
        'type'                       => 'varchar',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

if ( ! $installer->getAttributeId(Mage_Catalog_Model_Product::ENTITY, 'tax_code')) {
    $installer->addAttribute(Mage_Catalog_Model_Product::ENTITY, 'tax_code', array(
        'label'                      => 'Tax Code',
        'sort_order'                 => 10,
        'backend'                    => '',
        'type'                       => 'varchar',
        'group'                      => 'OrderFlow',
        'frontend'                   => '',
        'note'                       => null,
        'default'                    => null,
        'wysiwyg_enabled'            => false,
        'input'                      => 'text',
        'source'                     => null,
        'required'                   => false,
        'user_defined'               => false,
        'unique'                     => false,
        'global'                     => Mage_Catalog_Model_Resource_Eav_Attribute::SCOPE_GLOBAL,
        'visible'                    => true,
        'visible_on_front'           => false,
        'used_in_product_listing'    => false,
        'searchable'                 => false,
        'visible_in_advanced_search' => false,
        'filterable'                 => false,
        'filterable_in_search'       => false,
        'comparable'                 => false,
        'is_html_allowed_on_front'   => true,
        'apply_to'                   => 'simple',
        'is_configurable'            => false,
        'used_for_sort_by'           => false,
        'position'                   => 0,
        'used_for_promo_rules'       => false,
    ));
}

$installer->endSetup();